    {Fotosferex - program for calculating sunspots positions.
    Copyright (C) 1997-2001 Petr Kubanek <pkubanek@matfyz.cz>
    Copyright (C) 2002-2003 Michal Svanda <svanda@asu.cas.cz>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc.}

{$N+}

unit spots;

interface

uses Strings,Ids,WinDos,Objects, OWindows;

const err=0.000001;
      days:array[0..11] of byte =(31,28,31,30,31,30,31,31,30,31,30,31);
      NemaOkno:byte=0;
      MaOkno:byte=1;
      idString = 'SUN4';

      {datum a rotace pro vypocet rotace}
      NullJDDate=2450845;
      NullRotation=1932;
      MAxSpots = 20;   {pridal Svanda, maximalni pocet skvrn v jedne kresbe}


type PozorovatelChar=array[1..20] of Char;

     TSunVal=record
                B,P,L:double
             end;

     TDatum=record
                DD,YY,MM:word;
            end;

     TCas= record
                HH,MM:word;
                TimeZone:ShortInt;
                SDT:boolean;
            end;

     TSun=record
              Act,Iter1,Iter2:TSunVal;
          end;

     PSpot=^TSpot;
     TSpot=record
               cislo:word;
               Q,VR:real;
               l,b,r:real;
               pocet, pocetstred : integer;
           end;

       PData=^TData;
       TData=object {zakladni objek, obsahuje jak data tak samotne okno}
               size:byte; {velikost pole spots}
               Sun:TSun;
               Spots:array[1..maxspots] of PSpot;
               Datum:TDatum;
               Cas:TCas;
               Pozorovatel:PozorovatelChar;
               R:real;
               Podminky, Obraz : Byte;
               Next,Pred:PData;
               Parent:PWindow;

               Rotation:integer;
               JD:double;

               constructor Init(Where:PData);
               constructor Load(var S:TStream;Where:PData);
               destructor Done;virtual;
               procedure SetDate(Dat_in:TDatum;Cas_in:TCas;R_in:real;podm_in, obr_in:Byte);
               procedure Iter(Iter1_in,Iter2_in:TSunVal);
               procedure Calculate;
               procedure SetSun(S:TSun);
               procedure SetSpot(ID:byte;Q_in,VR_in:real;csl:byte;pocet_in, pocetstred_in : Integer);
               procedure InsertSpot(Q_in,VR_in:real;csl:byte;pocet_in, pocetstred_in : Integer);
               procedure DeleteSpot(ID:byte);
               procedure Store(var S:TStream);

            private
               procedure RecalculateSpot(ID:byte);

  end;

var  IsChanged:boolean;
function arcsin(x:double):double;

procedure Dat2Char(Dat:TDatum;out:PChar);
procedure NextDay(var Dat:TDatum);

{****************************************************************}
{***************  KONEC DEFINIC, ZACATEK PROGRAMU   *************}
{****************************************************************}

implementation

function arcsin(x:double):double;
var lo,hi,pul:double;

begin
    if (x<-1) or (x>1) then Halt(50);
    if x>0 then begin
                   lo:=0;
                   hi:=pi/2;
                end
           else begin
                   lo:=-pi/2;
                   hi:=0;
                end;
    pul:=(hi+lo)/2;
    while abs(x-sin(pul))>err do
          begin
              pul:=(hi+lo)/2;
              if sin(pul)>x then hi:=pul
                            else lo:=pul;
          end;
    arcsin:=pul;
end;


procedure Dat2Char(Dat:TDatum;out:PChar);
var pom:array[0..10] of char;
begin
   Str(Dat.DD:2,pom);
   StrCopy(out,pom);
   out:=StrCat(out,'.');
   out:=StrCat(out,month[Dat.MM]);
   Str(Dat.YY:4,pom);
   out:=StrCat(out,' ');
   out:=StrCat(out,pom);
end;

procedure NextDay(var Dat:TDatum);
begin
  if (Dat.MM=1) and (Dat.DD=29) and {unor, prestupny rok, den=29}
    ((Dat.YY mod 400=0) or ((Dat.YY mod 4=0) and (Dat.YY mod 100<>0)))
    then begin
       inc(Dat.MM);
       Dat.DD:=1;
    end
  else
  if Dat.DD=days[Dat.MM] then {jinak den je posledni v mesici}
     begin
       inc(Dat.MM);
       Dat.MM:=Dat.MM mod 12;
       Dat.DD:=1;
     end
     else inc(Dat.DD); {jinak zvec dny}
end;

{*********************** TData ***************************}

constructor TData.Init(Where:PData);
var pom1,pom2:word;
begin
 with Sun do begin
  Act.L:=0;
  Act.B:=0;
  Act.P:=0;
  Iter1.B:=0;
  Iter1.P:=0;
  Iter1.L:=0;
  Iter2.B:=0;
  Iter2.P:=0;
  Iter2.L:=0;
 end;
  Datum.YY:=1997;
  Datum.MM:=4;
  Datum.DD:=3;
  Cas.HH:=12;
  Cas.MM:=00;
  Cas.TimeZone:=0;
  Cas.SDT:=false;
  with Datum do GetDate(YY,MM,DD,pom1);
  with Cas do GetTime(HH,MM,pom1,pom2);
  Dec(Cas.HH);
  Dec(Datum.MM);
  size:=0;
  R:=12.5;
  Podminky := 1;
  Obraz := 1;
  Pred:=Where;
  if Pred=nil then Next:=nil
      else begin
         Next:=Pred^.Next;
         Pred^.Next:=@Self;
         if Next<>nil then Next^.Pred:=@Self;
     end;
  Parent:=nil;
  StrCopy(@Pozorovatel[1],'unknow');
end;

destructor TData.Done;
var i:byte;
begin
  for i:=1 to Size do DeleteSpot(i);
  if Pred<>nil then Pred^.Next:=Next;
  if Next<>nil then Next^.Pred:=Pred;
end;

procedure TData.SetSpot(ID:Byte;Q_in,VR_in:real;csl:byte;pocet_in, pocetstred_in : Integer);
begin
 if ID<=size then begin
     Spots[ID]^.Q:=Q_in*pi/180;
     Spots[ID]^.VR:=VR_in;
     Spots[ID]^.cislo:=csl;
     Spots[ID]^.Pocet := Pocet_in;
     Spots[ID]^.PocetStred := PocetStred_in;
     RecalculateSpot(ID);
   end;
 isChanged := true;
end;

procedure TData.InsertSpot(Q_in,VR_in:real;csl:byte;pocet_in, pocetstred_in : Integer);
begin
   inc(size);
   Spots[size]:=new(PSpot);
   SetSpot(size,Q_in,VR_in,csl, pocet_in, pocetstred_in);
   isChanged := true;
end;

procedure TData.DeleteSpot(ID:byte);
var i:byte;
begin
   if ID<=size then begin
      dispose(Spots[ID]);
      for i:=ID to size do Spots[i]:=Spots[i+1];
      dec(size);
   end;
   isChanged := true;
end;

procedure TData.RecalculateSpot(ID:byte);
begin
with Spots[ID]^ do
  begin
     r:=arcsin(VR);
     b:=arcsin(sin(Sun.Act.B)*cos(r)+cos(Sun.Act.B)*sin(r)*cos(Sun.Act.P-Q));
     l:=arcsin(sin(r)*sin(Sun.Act.P-Q)/cos(b))+Sun.Act.L;
     b:=b*180/pi;
     if l<0 then l:=l-trunc(l/(2*pi))*2*pi;
     if l>2*pi then l:=l-trunc(l/(2*pi))*2*pi;
     l:=l*180/pi;
   end;
end;

procedure TData.SetSun(S:TSun);
var i:byte;
begin
   Sun:=S;
   for i:=1 to size do RecalculateSpot(i);
end;

procedure TData.Iter(Iter1_in,Iter2_in:TSunVal);
var ERel:real;
begin
 with Sun do begin
   Iter1:=Iter1_in;
   Iter2:=Iter2_in;
   ERel:=(Cas.HH*60+Cas.MM)/1440;
   Act.L:=Iter1.L+((Iter2.L-Iter1.L)*ERel);
   Act.B:=Iter1.B+((Iter2.B-Iter1.B)*ERel);
   Act.P:=Iter1.P+((Iter2.P-Iter1.P)*ERel);
   SetSun(Sun);
  end;
end;


procedure TData.Calculate;
var Lo,DS,omega,LS,MS,n:double;
    PomDate:TDatum;

function GetJD(Dat_in:TDatum;Cas_in:integer):double;
begin
    GetJD:=longint(Dat_in.YY)*367-int((7*(longint(Dat_in.YY)+int((Longint(Dat_in.MM)+10)/12)))/4)
      +int(275*(Longint(Dat_in.MM)+1)/9)+Longint(Dat_in.DD)+
     (Cas_in)/1440+1721013.5;
end;

procedure CalculateForTime(JD:double;{Dat_in:TDatum;Cas_in:integer;}var Sun_out:TSunVal);
var pom,pom3,p1,p2:double;
begin
    n:=JD-2451545;
    LS:=280.4664485+0.9856474*n;
    MS:=(357.5277233+0.9856003*n)*pi/180;
    DS:=LS+1.915*sin(MS)+0.020*sin(2*MS);

    omega:=73.667+0.013958*(JD-2396757.5)/365.25;
    pom:=sin((ds-omega)*pi/180)/cos((ds-omega)*pi/180);
    Lo:=arctan(0.9920049*pom);

    pom3:=(ds-omega+180-Trunc((ds-omega+180)/360)*360);

    if pom3<0 then p1:=pom3+360
              else p1:=pom3;

    if lo<0 then p2:=lo*180/pi+360
            else p2:=lo*180/pi;

    if abs(p2-p1)>180 then Lo:=Lo+pi;

    Sun_out.L:=Lo-((14.18439716*(JD-2398220)*pi)/180);

    Sun_out.L:=Sun_out.L-Trunc(Sun_out.L/(2*pi))*2*pi;
    Sun_out.B:=arcsin(sin((ds-omega)*pi/180)*0.126199);
    Sun_out.P:=arctan(-0.4348124*cos(ds*pi/180))+arctan(-0.12721661*cos((ds-omega)*pi/180));

    if Sun_out.L<0 then Sun_out.L:=2*pi+Sun_out.L;

{    Sun_out.L:=Sun_out.L*180/(pi);
    Sun_out.B:=Sun_out.B*180/(pi);
    Sun_out.P:=Sun_out.P*180/(pi);}
end;

procedure CalculateRotation;
var PomDatum:double;
    PomSun:TSunVal;
    OldL:double;

begin
  PomDatum:=NullJDDate+(JD-trunc(JD))+1;
  Rotation:=NullRotation;
  CalculateForTime(PomDatum,PomSun);
  OldL:=PomSun.L;

  if PomDatum<=JD then
    begin
       while (PomDatum<=JD) do
        begin
          CalculateForTime(PomDatum,PomSun);
          if (PomSun.L>OldL) then inc(Rotation);
          OldL:=PomSun.L;
          PomDatum:=PomDatum+1;
        end;
    end
  else
    begin
       while (PomDatum>JD) do
        begin
          CalculateForTime(PomDatum,PomSun);
          if (PomSun.L<OldL) then dec(Rotation);
          OldL:=PomSun.L;
          PomDatum:=PomDatum-1;
        end;
    end;
end;


begin
    JD:=GetJD(Datum,Integer(Cas.HH)*60+Cas.MM);
    CalculateForTime(GetJD(Datum,Integer(Cas.HH)*60+Cas.MM),Sun.Act);
    CalculateForTime(GetJD(Datum,0),Sun.Iter1);
    PomDate:=Datum;
    NextDay(PomDate);
    CalculateForTime(GetJD(PomDate,0),Sun.Iter2);
    CalculateRotation;
    SetSun(Sun);
end;

procedure TData.SetDate(Dat_in:TDatum;Cas_in:TCas;R_in:real;podm_in, obr_in:Byte);
begin
   Datum:=Dat_in;
   Cas:=Cas_in;
   R:=R_in;
   Podminky := Podm_in;
   Obraz := Obr_in;
   isChanged := true;
end;

procedure TData.Store(var S:TStream);
procedure StoreSun(Sun:TSunVal);
begin
   S.Write(Sun.L,6);
   S.Write(Sun.B,6);
   S.Write(Sun.P,6);
end;

var i:byte;
  id : array[1..4] of char;
begin
   id := idstring;
   S.Write(id,4);
   S.Write(Size,2);
   i:=StrLen(@Pozorovatel[1]);
   S.Write(i,1);
   S.Write(Pozorovatel,i);
   S.Write(R,6);
   S.Write(Podminky,2);
   S.Write(Obraz, 2);
   S.Write(Datum.YY,4);
   S.Write(Datum.MM,4);
   S.Write(Datum.DD,4);
   S.Write(Cas.HH,4);
   S.Write(Cas.MM,4);
   S.Write(Cas.TimeZone,2);
   S.Write(Cas.SDT,2);
   StoreSun(Sun.Act);
   StoreSun(Sun.Iter1);
   StoreSun(Sun.Iter2);
   for i:=1 to Size do begin
        S.Write(Spots[i]^.cislo,4);
        S.Write(Spots[i]^.Q,6);
        S.Write(Spots[i]^.VR,6);
        S.Write(Spots[i]^.Pocet, 4);
        S.Write(Spots[i]^.PocetStred, 4);
      end;
   if Next<>nil then Next^.Store(S)
end;

constructor TData.Load(var S:TStream;where:PData);

procedure LoadSun(var Sun:TSunVal);
begin
   S.Read(Sun.L,6);
   S.Read(Sun.B,6);
   S.Read(Sun.P,6);
end;

var i:byte;
  id : array[1..4] of char;
  novy : boolean;
begin
   Init(Where);
   S.Read(id,4);
   novy:=(id=idstring);
   if not novy then begin
     S.Seek(S.GetPos-4);
     S.Read(Size,2);
     S.Read(i,1);
     S.Read(Pozorovatel,i);
     Byte(Pozorovatel[i+1]):=0;
     S.Read(R,6);
     S.Read(Datum.YY,4);
     S.Read(Datum.MM,4);
     S.Read(Datum.DD,4);
     S.Read(Cas.HH,4);
     S.Read(Cas.MM,4);
     S.Read(Cas.TimeZone,2);
     S.Read(Cas.SDT,2);
     LoadSun(Sun.Act);
     LoadSun(Sun.Iter1);
     LoadSun(Sun.Iter2);
     for i:=1 to Size do begin
        Spots[i]:=New(PSpot);
        S.Read(Spots[i]^.cislo,4);
        S.Read(Spots[i]^.Q,6);
        S.Read(Spots[i]^.VR,6);
        Spots[i]^.Pocet := 0;
        Spots[i]^.PocetStred := 0;
        RecalculateSpot(i);
        end;
      Podminky := 255;
      Obraz := 255;
   end
   else begin
     S.Read(Size,2);
     S.Read(i,1);
     S.Read(Pozorovatel,i);
     Byte(Pozorovatel[i+1]):=0;
     S.Read(R,6);
     S.Read(Podminky, 2);
     S.Read(Obraz, 2);
     S.Read(Datum.YY,4);
     S.Read(Datum.MM,4);
     S.Read(Datum.DD,4);
     S.Read(Cas.HH,4);
     S.Read(Cas.MM,4);
     S.Read(Cas.TimeZone,2);
     S.Read(Cas.SDT,2);
     LoadSun(Sun.Act);
     LoadSun(Sun.Iter1);
     LoadSun(Sun.Iter2);
     for i:=1 to Size do begin
        Spots[i]:=New(PSpot);
        S.Read(Spots[i]^.cislo,4);
        S.Read(Spots[i]^.Q,6);
        S.Read(Spots[i]^.VR,6);
        S.Read(Spots[i]^.Pocet, 4);
        S.Read(Spots[i]^.PocetStred, 4);
        RecalculateSpot(i);
        end;
   end;

end;

begin

end.