    {Fotosferex - program for calculating sunspots positions.
    Copyright (C) 1997-2001 Petr Kubanek <pkubanek@matfyz.cz>
    Copyright (C) 2002-2003 Michal Svanda <svanda@asu.cas.cz>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc.
    }

{Latest changes

*** upto March 28th 2003  --  Some changes in program layout (number of groups of sunspots can reach
20 now, rotation of projection plate by 180 deg, changes in data format - now you have to
put two indices of weather and conditions, you can add number of sunspots in each group -
this can help for making reports by another program, id-number of sunspot is stored in an
integer value, so it can reach more than 255 without overflow, etc.)

*** March 28th 2003  --  Found critical mistake in editing dialog of sunspot. There was a "R"
and should be "VR", coordinates of sunspots could been calculated wrong if sunspot was edited.

*** April 11th 2003  --  Because of using UT in Solar Section, TDatumDlg modified to use only
three timezones (UT, CET, CEST), UT is default. No matter which timezone you choose from the
roll-menu, time you put is converted into UT (depends on timezone, you choosed) and in data file
is date stored using UT only.

*** June 14th 2003 -- Modified Tab-order in some dialogs and it can make data input easier using
keyboard only (it is faster :-) ).

}

{$X+}{$T-}{$N+}
{$M 8192, 40000}
program Fotosferex;

{$R sun}

uses OWindows, ODialogs, Objects, WinProcs, WinTypes, Strings, Win31, WinCrt,Spots ,
     Ids,CommDlg,Toolbar, WinDos;

type

  PMyApp = ^TMyApp;
  TMyApp = object(TApplication)
    procedure InitInstance;virtual;
    function ProcessAppMsg(var Message: TMsg): boolean;virtual;
    procedure InitMainWindow; virtual;
  end;

  PMainWindow = ^TMainWindow;
  TMainWindow = object(TMDIWindow)
       ToolBar:PToolBar;
       StatusBar:PStatusBar;
       WinCount:byte;
{       Data,Hlava:PData;}
       FileName:array[0..255] of char;
       OpenFN:TOpenFileName;
       Filter:array [0..100] of Char;
       FullFileName:array [0..255] of Char;
       constructor Init(ATitle:PChar;AMenu:HMenu);
       destructor Done;virtual;
       procedure GetWindowClass(var WndClass: TWndClass);virtual;
       procedure SetUpWindow; virtual;
       procedure LoadData(var Msg:TMessage);virtual CM_FIRST+CM_LOADDATA;
       procedure AddSun(var Msg:TMessage);virtual CM_FIRST+cm_addsun;
       procedure ChangeCount(var Msg:TMessage);virtual WM_USER+12;
       procedure Exit; virtual cm_first+id_exit;
       procedure About;virtual CM_FIRST+id_o;
       procedure Pomoc; virtual cm_first+id_help;
       procedure PomocIndex; virtual cm_first+id_helpindex;
       procedure PomocProgram; virtual cm_first+id_helpprog;
       procedure WMSize(var Msg:TMessage);virtual wm_first+wm_size;
       procedure SetStatusText(var Msg:TMessage);virtual am_SetStatusText;
    end;

 PMyWindow = ^TMyWindow;
 TMyWindow = object(TWindow)

     Data,Hlava:PData;
     R:integer;
     Vel,ActiveID:byte;
     Stred:TPoint;
     Sun_in:HBrush;
     BrushLog:TLogBrush;
     FileName:array[0..255] of char;
     OpenFN:TOpenFileName;
     Filter:array [0..100] of Char;
     FullFileName:array [0..255] of Char;


     constructor Init(AParent: PWindowsObject; ATitle: PChar);
     constructor Load(AParent:PWindowsObject;var S:TStream);
     destructor Done;virtual;

     procedure GetWindowClass(var WndClass: TWndClass); virtual;
     procedure SetUpWindow; virtual;
     procedure WMMDIActivate(var Msg:TMessage);virtual WM_FIRST+WM_MDIACTIVATE;
     procedure SetMenu(Style:word);
     procedure Paint(PaintDC : HDC; var PaintInfo : TPaintStruct); virtual;
     procedure WMSize(var Msg:TMessage);virtual WM_FIRST+WM_SIZE;
     procedure WMLButtonDown(var Msg:TMessage); virtual WM_FIRST+WM_LBUTTONDOWN;
     procedure WMRButtonUp(var Msg:TMessage); virtual WM_FIRST+WM_RBUTTONUP;
     function CanClose:boolean;virtual;

     procedure ChooseSun(var Msg:TMessage);virtual CM_FIRST+CM_CHOOSESUN;
     procedure SaveData(var Msg:TMessage);virtual CM_FIRST+CM_SAVEDATA;
     procedure SaveDataAs(var Msg:TMessage);virtual CM_FIRST+CM_SAVEDATAAS;

     procedure AddObs(var Msg:TMessage);virtual CM_FIRST+CM_ADDOBS;
     procedure DeleteObs(var Msg:TMessage);virtual CM_FIRST+CM_DELETEOBS;
     procedure PrevObs(var Msg:TMessage);virtual CM_FIRST+CM_PREVOBS;
     procedure NextObs(var Msg:TMessage);virtual CM_FIRST+CM_NEXTOBS;
     procedure Vyhodnot(var Msg:TMessage);virtual CM_FIRST+CM_vyhodnotit;


     procedure Souradnice; virtual cm_first+id_spot;
     procedure Datum; virtual cm_first+id_datum;
     procedure Iteruj; virtual cm_first+id_iter;
     procedure Insert; virtual cm_first+id_insert;
     procedure Delete; virtual cm_first+id_delete;
     procedure NextSpot; virtual cm_first+id_next;
     procedure LastSpot; virtual cm_first+111;
     procedure SelectSpot; virtual cm_first+112;
  end;

  PIterDlg=^TIterDlg;
  TIterDlg=object(TDialog)
     Datum:TDatum;
     Iter_1,Iter_2:TSunVal;
     constructor Init(AParent:PWindowsObject;Data:PData);
     procedure   OK(var Msg:TMessage); virtual id_first+id_ok;
     procedure   SetUpWindow; virtual;
  end;

  PDatumDlg=^TDatumDlg;
  TDatumDlg=object(TDialog)
     Dat:TDatum;
     Cas:TCas;
     Pozo:PChar;
     R:real;
     PozPodm, PozObr : Byte;
     constructor Init(AParent:PWindowsObject;Dat_in:TDatum;Cas_in:TCas;R_in:real;Poz_in:PChar;podm_in, obr_in:Byte);
     procedure   OK(var Msg:TMessage); virtual id_first+id_ok;
     procedure   SetUpWindow; virtual;
  end;

  PSpotDlg=^TSpotDlg;
  TSpotDlg=object(TDialog)
     Q,R,RMax:real;
     cislo:word;
     pocet, pocetstred : Integer;
     constructor Init(AParent:PWindowsObject;Q_in,R_in:real;RMax_in:real;cislo_in:word;pocet_in, pocetstred_in:Integer);
     procedure   OK(var Msg:TMessage); virtual id_first+id_ok;
     procedure   SetUpWindow; virtual;
  end;

  var
    Pozorovatele : array[0..255] of PChar;
    PocetPozorovatelu : integer;

{****************************************************************}
{***************  KONEC DEFINIC, ZACATEK PROGRAMU   *************}
{****************************************************************}

{******** POMOCNA PROCEDURA, NASTAVI HODNOTY SLUNCE*************}

procedure SetSunVal(Dlg:LongInt;Start_id:integer;Val:TSunVal);
var pom:array[0..10] of char;
begin
  Str((Val.L*18000/pi)/100:3:10,pom);
  SendMessage(GetDlgItem(Dlg,Start_id),WM_SETTEXT,0,LongInt(@pom[0]));
  Str((Val.B*1800/pi)/10:1:10,pom);
  SendMessage(GetDlgItem(Dlg,Start_id+1),WM_SETTEXT,0,LongInt(@pom[0]));
  Str((Val.P*1800/pi)/10:3:10,pom);
  SendMessage(GetDlgItem(Dlg,Start_id+2),WM_SETTEXT,0,LongInt(@pom[0]));
end;

function GetSunVal(Dlg:LongInt;Start_id:integer;var Vals:TSunVal):boolean;
var ch:array[0..10] of char;
    odpad:integer;
begin
  GetSunVal:=false;
  GetDlgItemText(Dlg, Start_id, ch, 10);
  Val(ch,Vals.L,odpad);
  if odpad=0 then
     begin
          Vals.L:=Vals.L*pi/180;
          GetDlgItemText(Dlg, Start_id+1, ch, 20);
          Val(ch,Vals.B,odpad);
          if (odpad=0) and (abs(Vals.b)<=7.3) then
             begin
                  Vals.B:=Vals.B*pi/180;
                  GetDlgItemText(Dlg, Start_id+2, ch, 20);
                  Val(ch,Vals.P,odpad);
                  Vals.P:=Vals.P*pi/180;
                  GetSunVal:=(odpad=0);
             end;
     end;
end;

{********************* TITERDLG *********************************}

constructor TIterDlg.Init(AParent:PWindowsObject;Data:PData);
begin
  inherited Init(AParent,'ITER');
  Datum:=Data^.Datum;
  Iter_1:=Data^.Sun.Iter1;
  Iter_2:=Data^.Sun.Iter2;
end;

procedure   TIterDlg.SetUpWindow;
const ho:PChar='   0 Hodin S';
      ch:PChar='                                          ';
begin
   inherited SetUpWindow;
   Dat2Char(Datum,ch);
   ch:=StrCat(ch,ho);
   SendMessage(GetDlgItem(hWindow,310),WM_SETTEXT,0,LongInt(@ch[0]));
   NextDay(Datum);
   Dat2Char(Datum,ch);
   ch:=StrCat(ch,ho);
   SendMessage(GetDlgItem(hWindow,315),WM_SETTEXT,0,LongInt(@ch[0]));
   SetSunVal(hWindow,300,Iter_1);
   SetSunVal(hWindow,305,Iter_2);
end;

procedure TIterDlg.OK(var Msg:TMessage);
begin
  if GetSunVal(hWindow,300,Iter_1) and GetSunVal(hWindow,305,Iter_2) then inherited OK(Msg);
end;

{********************* TDATUMLG *********************************}

constructor TDatumDlg.Init(AParent:PWindowsObject;Dat_in:TDatum;Cas_in:TCas;R_in:real;Poz_in:PChar;Podm_in,Obr_in:Byte);
begin
   inherited Init(AParent,'DATUM');
   Dat:=Dat_in;
   Cas:=Cas_in;
   Pozo:=Poz_in;
   R:=R_in;
   Cas.HH:=(Cas.HH+Cas.TimeZone) mod 24;
   if Cas.SDT then Cas.HH:=(Cas.HH+1) mod 24;
   PozPodm := Podm_in;
   PozObr := Obr_in;
end;

procedure   TDatumDlg.SetUpWindow;
var ch:array[0..20] of char;
    i:byte;
    tz : byte;
begin

   inherited SetUpWindow;
   for i:=0 to 2 do begin
       SendMessage(GetDlgItem(hWindow,207),CB_ADDSTRING,0,LongInt(TZones[i]));
    end;
   for i:=0 to 11 do begin
       SendMessage(GetDlgItem(hWindow,id_month),CB_ADDSTRING,0,LongInt(Month[i]));
    end;
   for i:=0 to PocetPozorovatelu do begin
       SendMessage(GetDlgItem(hWindow,231),CB_ADDSTRING,0,LongInt(Pozorovatele[i]));
    end;

   SendMessage(GetDlgItem(hWindow,id_month),CB_SETCURSEL,Dat.MM,0);
   Str(Dat.DD,ch);
   SendMessage(GetDlgItem(hWindow,id_day),WM_SETTEXT,0,LongInt(@ch[0]));
   Str(Dat.YY,ch);
   SendMessage(GetDlgItem(hWindow,id_year),WM_SETTEXT,0,LongInt(@ch[0]));
   Str(Cas.HH,ch);
   SendMessage(GetDlgItem(hWindow,id_hour),WM_SETTEXT,0,LongInt(@ch[0]));
   Str(Cas.MM,ch);
   SendMessage(GetDlgItem(hWindow,id_min),WM_SETTEXT,0,LongInt(@ch[0]));
   Str(R:2:1,ch);
   SendMessage(GetDlgItem(hWindow,230),WM_SETTEXT,0,LongInt(@ch[0]));
   Str(PozPodm, Ch);
   SendMessage(GetDlgItem(hWindow,205),WM_SETTEXT,0,LongInt(@ch[0]));
   Str(PozObr, Ch);
   SendMessage(GetDlgItem(hWindow,206),WM_SETTEXT,0,LongInt(@ch[0]));
   SendMessage(GetDlgItem(hWindow,231),WM_SETTEXT,0,LongInt(Pozo));

   if (Cas.TimeZone=1) and (not Cas.SDT) then tz := 1
    else if (Cas.TimeZone=1) and Cas.SDT
      then tz := 2 else tz := 0;
   SendMessage(GetDlgItem(hWindow,207),CB_SETCURSEL,tz,0);
end;

procedure   TDatumDlg.OK(var Msg:TMessage);
var ch:array[0..40] of char;
    odpad : integer;
    tz : byte;

function PRestupny(rok:Word):Boolean;
begin
  Prestupny := false;
  if (rok mod 400)=0 then prestupny := true
  else if ((rok mod 4)=0) and ((rok mod 100) <> 0) then prestupny := true;
end;

begin
  tz:=SendMessage(GetDlgItem(hWindow,207),CB_GETCURSEL,0,0);
  Dat.MM:=SendMessage(GetDlgItem(hWindow,id_month),CB_GETCURSEL,0,0);
{  Cas.SDT:=SendMessage(GetDlgItem(hWindow,211),BM_GETCHECK,0,0)=1;}
  GetDlgItemText(hWindow, 231, Pozo, 20);
  GetDlgItemText(hWindow, id_day, ch, 20);
  Val(ch,Dat.DD,odpad);
  with Dat do
  begin
    if (dd=30) and (mm=1) then Odpad:=1;
    if (dd=31) and ((mm=1) or (mm=3) or (mm=5) or (mm=8) or (mm=10)) then Odpad:=1;
  end;
  if (odpad=0) and (Dat.DD<32) then
     begin
          GetDlgItemText(hWindow,230, ch, 20);
          Val(ch,R,odpad);
    if (odpad=0) and (R>0) then
        begin
          GetDlgItemText(hWindow,id_year, ch, 20);
          Val(ch,Dat.YY,odpad);
          if (dat.mm=1) and (dat.dd=29) and not Prestupny(dat.yy) then odpad := 1;
          if (odpad=0) then
             begin
               GetDlgItemText(hWindow, 205, ch, 20);
               Val(ch, PozPodm, Odpad);
               if ((odpad=0) and (PozPodm >=1) and (PozPodm<=5)) or (PozPodm=255) then
               begin
                 GetDlgItemText(hWindow, 206, ch, 20);
                 Val(Ch, PozObr, Odpad);
                 if ((odpad=0) and (PozObr >=1) and (PozObr<=5)) or (PozObr=255) then
                 begin
                  GetDlgItemText(hWindow, id_hour, ch, 20);
                  Val(ch,Cas.HH,odpad);
                  if (odpad=0) and (Cas.HH<24) and (cas.HH>=0) then
                    begin
                       GetDlgItemText(hWindow, id_min, ch, 20);
                       Val(ch,Cas.MM,odpad);
                       if (odpad=0) then TDialog.OK(Msg);
                    end;
                 end;
                end;
              end;
          end;
      end;
   Cas.SDT := false;
   Cas.HH := Cas.HH-tz;
   Cas.Timezone := 0;
{   Cas.HH:=(Cas.HH+(24-tz)) mod 24;
   if Cas.SDT then Cas.HH:=(Cas.HH+(24-1)) mod 24;}
end;

{***************************** TSPOTDLG ***************************** }
constructor TSpotDlg.Init(AParent:PWindowsObject;Q_in,R_in:real;RMax_in:real;cislo_in:word;pocet_in, pocetstred_in:Integer);
begin
   inherited Init(AParent,'SOURADNICE');
   Q:=Q_in;
	 R:=R_in;
   RMax:=RMax_in;
   cislo:=cislo_in;
   Pocet := Pocet_in;
   PocetStred := PocetStred_in;
end;

procedure   TSpotDlg.SetUpWindow;
var ch:array[0..20] of char;
begin
   inherited SetUpWindow;
   Q:=Q*180/pi;
   Str(Q:3:1,ch);
   SetDlgItemText(hWindow,103,ch);
   Str(R:2:1,ch);
   SetDlgItemText(hWindow,104,ch);
   Str(cislo,ch);
   SetDlgItemText(hWindow,105,ch);
   Str(pocet, ch);
   SetDlgItemText(hWindow,106,ch);
   Str(pocetstred, ch);
   SetDlgItemText(hWindow,107,ch);
end;

procedure   TSpotDlg.OK(var Msg:TMessage);
var ch:array[0..40] of char;
    odpad : integer;

begin
  GetDlgItemText(hWindow, 103, ch, 20);
  Val(ch,Q,odpad);
  if (Q<-360) or (Q>360) then odpad:=1;
  if odpad=0 then
   begin
      GetDlgItemText(hWindow, 105, ch, 20);
      Val(ch,cislo,odpad);
      if odpad=0 then
      begin
        GetDlgItemText(hWindow, 106, ch, 20);
        Val(ch,pocet,odpad);
        if (odpad=0) and (pocet >= 1) then
        begin
          GetDlgItemText(hWindow, 107, ch, 20);
          Val(ch,pocetstred,odpad);
          if (odpad=0) and (pocetstred >= 0) and (pocetstred<=pocet) then
          begin
            GetDlgItemText(hWindow, 104, ch, 20);
            Val(ch,R,odpad);
            if (odpad=0) and (R>=0) and (R<=RMax) then TDialog.OK(Msg)
                                               else SetFocus(GetDlgItem(hWindow,104));
          end
          else SetFocus(GetDlgItem(hWindow,107));
        end
        else SetFocus(GetDlgItem(hWindow,106));
      end
      else SetFocus(GetDlgItem(hWindow,105));
  end
  else SetFocus(GetDlgItem(hWindow,103));
end;

{ ***************************** TMyWindow **************************** }

constructor TMyWindow.Init(AParent: PWindowsObject; ATitle: PChar);
begin
    inherited Init(AParent, ATitle);
    Attr.Style := Attr.Style or ws_Overlapped;
    Attr.H:=480;
    Attr.W:=480;

    Vel:=22;  {bylo tu Vel := 45}
    IsChanged:=true;

    Hlava:=nil;
    Data:=New(PData,Init(Hlava));
    Hlava:=Data;

    ActiveID:=0;

{    Scroller:= New (PScroller , Init (@Self,10,10,10,10));
    Scroller^.AutoMode:=True;}
    Stred.x:=220;
    Stred.y:=220;
    r:=180;
  end;

constructor TMyWindow.Load(AParent:PWindowsObject;var S:TStream);
var i:byte;

begin
   if S.GetSize>0 then begin
      Init(AParent,NazevApp);
      Hlava:=New(PData,Load(S,nil));
      Data:=Hlava;
      while S.GetSize>S.GetPos do begin
        Data:=new(PData,Load(S,Hlava));
      end;
      IsChanged:=false;
{      InvalidateRect(hWindow,nil,true);}
  end;
end;

procedure TMyWindow.GetWindowClass(var WndClass: TWndClass);
    begin
      inherited GetWindowClass(WndClass);
      WndClass.hIcon := LoadIcon(hInstance, 'EINSTEIN');
    end;

destructor TMyWindow.Done;
  begin
{    Dispose(Scroller, Done);}
    SetMenu(MF_GRAYED);
    SendMessage(parent^.hWindow,WM_USER+12,2,0);
    while Hlava<>nil do begin
        Data:=Hlava^.Next;
        Dispose(Hlava,Done);
        Hlava:=Data;
     end;
    inherited Done;
  end;

{************************* KONEC DEFINIC TMYWINDOW*************************}


procedure TMyWindow.SetUpWindow;
begin
   inherited SetUpWindow;
   Hlava^.Parent:=@Self;

   StrCopy(FullFileName, '');
   StrCopy(FileName, '*.sun');
   FillChar(Filter, SizeOf(Filter), #0);  { Set up for double null at end }
   StrCopy(Filter, 'FOTOSFEREX - data(*.sun)');
   StrCopy(@Filter[25], '*.sun');
   StrCopy(@Filter[31], 'Vechny soubory(*.*)');
   StrCopy(@Filter[52], '*.*');
   FillChar(OpenFN, SizeOf(TOpenFileName), #0);
   with OpenFN do
   begin
     hInstance     := HInstance;
     hwndOwner     := HWindow;
     lpstrFile     := FullFileName;
     lpstrFilter   := Filter;
     lpstrFileTitle:= FileName;
     lpstrCustomFilter:=nil;
     flags         := ofn_FileMustExist;
     lStructSize   := sizeof(TOpenFileName);
     nFilterIndex  := 1;       {Index into Filter String in lpstrFilter}
     nMaxFile      := SizeOf(FullFileName);
     lpstrDefEXt   := DefExt;
   end;

   SendMessage(parent^.hWindow,WM_USER+12,1,0);
end;

procedure TMyWindow.WMMDIActivate(var Msg:TMessage);
begin
   inherited WMMDIActivate(Msg);
   if Msg.wParam<>WA_INACTIVE then
   if Data^.Size=0 then SetMenu(MF_GRAYED)
                   else SetMenu(MF_ENABLED);
end;

procedure TMyWindow.SetMenu(Style:word);
var AMenu:HMenu;
begin
   AMenu:=GetMenu(Application^.MainWindow^.hWindow);
   EnableMenuItem(AMenu,id_spot,Style);
   EnableMenuItem(AMenu,id_delete,Style);
   EnableMenuItem(AMenu,110,Style);
   EnableMenuItem(AMenu,111,Style);
end;

procedure TMyWindow.Paint(PaintDC : HDC; var PaintInfo : TPaintStruct);

  var Styl_Cary : HPen;
      x,y,uhel:integer;
      pom:string[10];
      ch:PChar;
      pom1:real;

  const step=pi/180;

procedure PaintSpot(ID:byte);
begin


    {tady se kresli skvrny, tady to prijde otocit !!!}


{    x:=-round(sin(Data^.Spots[ID]^.Q)*Data^.Spots[ID]^.VR*R)+Stred.X;
    y:=round(cos(Data^.Spots[ID]^.Q)*Data^.Spots[ID]^.VR*R)+Stred.Y;}
    x:=round(sin(Data^.Spots[ID]^.Q)*Data^.Spots[ID]^.VR*R)+Stred.X;
    y:=-round(cos(Data^.Spots[ID]^.Q)*Data^.Spots[ID]^.VR*R)+Stred.Y;
    Ellipse(PaintDC,x-5,y-5,x+5,y+5);

    Rectangle(PaintDC,ID*Vel+5,PaintInfo.rcPaint.bottom-45,(ID+1)*Vel+5,PaintInfo.rcPaint.bottom);

    Str(Data^.Spots[ID]^.cislo:2,pom);
    TextOut(PaintDC,ID*Vel+5,PaintInfo.rcPaint.bottom-45,@pom[1],byte(pom[0]));

    Str(Round(10*Data^.Spots[ID]^.b)/10:3:1,pom);
    TextOut(PaintDC,ID*Vel+5,PaintInfo.rcPaint.bottom-30,@pom[1],byte(pom[0]));

    Str(Round(10*Data^.Spots[ID]^.l)/10:3:1,pom);
    TextOut(PaintDC,ID*Vel+5,PaintInfo.rcPaint.bottom-15,@pom[1],byte(pom[0]));
end;

  begin
     GetClientRect(hWindow,PaintInfo.rcPaint);

     GetMem(ch,50);

     Styl_Cary:=CreatePen(PS_Solid, 1, RGB(0,0,0));
     SetTextColor(PaintDC,RGB(0,0,0));
     BrushLog.lbStyle:=BS_SOLID;

     BrushLog.lbColor:=RGB($FF,$FF,$FF);

     BrushLog.lbColor:=RGB($FF,$FF,$AF);
     Sun_in:=CreateBrushIndirect(BrushLog);
     SelectObject(PaintDC,Sun_in);
     Ellipse(PaintDC,Stred.X-r,Stred.Y-r,Stred.X+r,Stred.Y+r);

     SetTextColor(PaintDC,RGB($FF,$FF,$FF));

     DeleteObject(Sun_in);

     for uhel:=1 to Data^.size do begin
            if uhel=ActiveID then BrushLog.lbColor:=RGB(0,0,0)
                             else BrushLog.lbColor:=RGB(uhel*50+100,uhel*22+44,uhel*15+30);
            SetBkColor(PaintDC,BrushLog.lbColor);
            Sun_in:=CreateBrushIndirect(BrushLog);
            SelectObject(PaintDC,Sun_in);

            PaintSpot(uhel);

            DeleteObject(Sun_in);
       end;

     BrushLog.lbColor:=RGB($FF,$FF,$FF);
     Sun_in:=CreateBrushIndirect(BrushLog);
     SelectObject(PaintDC,Sun_in);

     Rectangle(PaintDC,(uhel+1)*Vel+5,PaintInfo.rcPaint.bottom-45,
          (uhel+1)*Vel+Vel+6,PaintInfo.rcPaint.bottom+5);

     DeleteObject(Sun_in);

     SetBkColor(PaintDC,RGB($F0,$F0,$F0));
     SetTextColor(PaintDC,RGB($00,$00,$00));

     TextOut(PaintDC,5,0,'O:',2);
     TextOut(PaintDC,20,0,@Data^.Pozorovatel[1],StrLen(@Data^.Pozorovatel[1]));

     Str(Data^.JD:10:8,pom);
     TextOut(PaintDC,5,20,'J:',2);
     TextOut(PaintDC,20,20,@pom[1],byte(pom[0]));

     Str(Data^.Rotation,pom);
     TextOut(PaintDC,5,40,'R:',2);
     TextOut(PaintDC,20,40,@pom[1],byte(pom[0]));

     Str(Round(Data^.Sun.Act.L*1800/pi)/10:3:1,pom);
     TextOut(PaintDC,5,60,'L:',2);
     TextOut(PaintDC,20,60,@pom[1],byte(pom[0]));

     Str(Round(Data^.Sun.Act.B*1800/pi)/10:1:1,pom);
     TextOut(PaintDC,5,80,'B:',2);
     TextOut(PaintDC,20,80,@pom[1],byte(pom[0]));

     Str(Round(Data^.Sun.Act.P*1800/pi)/10:3:1,pom);
     TextOut(PaintDC,5,100,'P:',2);
     TextOut(PaintDC,20,100,@pom[1],byte(pom[0]));

     StrCopy(ch,NazevApp);
     Str(Data^.Datum.DD:2,pom);
     ch:=StrCat(ch,' ');
     ch:=StrCat(ch,@pom[1]);
     ch[byte(pom[0])+11]:='.';
     byte(ch[byte(pom[0])+12]):=0;
     ch:=StrCat(ch,Month[Data^.Datum.MM]);
     ch:=StrCat(ch,' ');
     uhel:=StrLen(ch)+4;
     Str(Data^.Datum.YY:4,pom);
     ch:=StrCat(ch,@pom[1]);
     ch[uhel]:=char(0);
     ch:=StrCat(ch,' ');
     Str(Data^.Cas.HH:2,pom);
     ch:=StrCat(ch,@pom[1]);
     ch[uhel+3]:=':';
     ch[uhel+4]:=char(0);
     Str(Data^.Cas.MM:2,pom);
     ch:=StrCat(ch,@pom[1]);
     ch[uhel+6]:=char(0);
     ch:=StrCat(ch,' UT');
     SendMessage(hWindow,WM_SETTEXT,0,LongInt(ch));

     SelectObject(PaintDC,Styl_Cary);

     for uhel:=0 to 360 do
         begin
              pom1:=uhel*step;
              x:=Round(sin(pom1)*r);
              y:=Round(cos(pom1)*r);
              MoveTo(PaintDC,Stred.X+x,Stred.Y+y);
              if uhel mod 5=0 then LineTo(PaintDC,Stred.X+Round(1.1*x),Stred.Y+Round(1.1*y))
                              else LineTo(PaintDC,Stred.X+Round(1.05*x),Stred.Y+Round(1.05*y));
         end;

     {Tady se kresli orientace Slunce -- rotacni osa atd.}

     MoveTo(PaintDC, Stred.X-Round(1.2*r), Stred.Y);
     LineTo(PaintDC, Stred.X+Round(1.2*r), Stred.Y);
     MoveTo(PaintDC, Stred.X, Stred.Y);
{     LineTo(PaintDC, Stred.X, Stred.Y+Round(1.1*r));}
     LineTo(PaintDC, Stred.X, Stred.Y-Round(1.1*r));

     {ted se vykresli polohy svetovych stran}
{     TextOut(PaintDC,Stred.X-Round(1.2*r),Stred.Y-8,'E',1);
     TextOut(PaintDC,Stred.X+Round(1.2*r),Stred.Y-8,'W',1);
     TextOut(PaintDC,Stred.X-5,Stred.Y+Round(1.1*r),'N',1);
     TextOut(PaintDC,Stred.X-5,Stred.Y-Round(1.2*r),'S',1);}

     TextOut(PaintDC,Stred.X-Round(1.2*r),Stred.Y-8,'W',1);
     TextOut(PaintDC,Stred.X+Round(1.2*r),Stred.Y-8,'E',1);
     TextOut(PaintDC,Stred.X-5,Stred.Y+Round(1.1*r),'S',1);
     TextOut(PaintDC,Stred.X-5,Stred.Y-Round(1.2*r),'N',1);

{     x:=round(sin(-Data^.Sun.Act.P)*1.2*r);
     y:=round(cos(-Data^.Sun.Act.P)*1.2*r);}
     x:=round(sin(-Data^.Sun.Act.P)*1.2*r);
     y:=round(cos(-Data^.Sun.Act.P)*1.2*r);

     MoveTo(PaintDC,Stred.X+x,Stred.Y+y);
     LineTo(PaintDC,Stred.X-x,Stred.Y-y);

     BrushLog.lbColor:=RGB($00,$FF,$00);
     SetBkColor(PaintDC,RGB($00,$FF,$00));
     Sun_in:=CreateBrushIndirect(BrushLog);
     SelectObject(PaintDC,Sun_in);

     {ted se vykresli znacky heliocentrickych stran -- v zelenem kolecku}

{     Ellipse(PaintDC,Stred.X+x-10,Stred.Y+y-10,Stred.X+x+10,Stred.Y+y+10);
     TextOut(PaintDC,Stred.X+x-5,Stred.Y+y-8,'N',1);

     Ellipse(PaintDC,Stred.X-x-10,Stred.Y-y-10,Stred.X-x+10,Stred.Y-y+10);
     TextOut(PaintDC,Stred.X-x-4,Stred.Y-y-8,'S',1);}
     Ellipse(PaintDC,Stred.X+x-10,Stred.Y+y-10,Stred.X+x+10,Stred.Y+y+10);
     TextOut(PaintDC,Stred.X+x-5,Stred.Y+y-8,'S',1);

     Ellipse(PaintDC,Stred.X-x-10,Stred.Y-y-10,Stred.X-x+10,Stred.Y-y+10);
     TextOut(PaintDC,Stred.X-x-4,Stred.Y-y-8,'N',1);


     {cara N-S}
     MoveTo(PaintDC,Stred.X-y,Stred.Y+x);
     LineTo(PaintDC,Stred.X-Round(y/1.2),Stred.Y+Round(x/1.2));

     MoveTo(PaintDC,Stred.X+y,Stred.Y-x);
     LineTo(PaintDC,Stred.X+Round(y/1.2),Stred.Y-Round(x/1.2));

{     Ellipse(PaintDC,Stred.X-y-10,Stred.Y+x-10,Stred.X-y+10,Stred.Y+x+10);
     TextOut(PaintDC,Stred.X-y-4,Stred.Y+x-8,'E',1);

     Ellipse(PaintDC,Stred.X+y-10,Stred.Y-x+10,Stred.X+y+10,Stred.Y-x-10);
     TextOut(PaintDC,Stred.X+y-7,Stred.Y-x-8,'W',1);}
     Ellipse(PaintDC,Stred.X-y-10,Stred.Y+x-10,Stred.X-y+10,Stred.Y+x+10);
     TextOut(PaintDC,Stred.X-y-4,Stred.Y+x-8,'W',1);

     Ellipse(PaintDC,Stred.X+y-10,Stred.Y-x+10,Stred.X+y+10,Stred.Y-x-10);
     TextOut(PaintDC,Stred.X+y-7,Stred.Y-x-8,'E',1);

     DeleteObject(Sun_in);

     BrushLog.lbColor:=RGB($FF,$FF,$FF);
     SetBkColor(PaintDC,RGB($FF,$FF,$FF));
     Sun_in:=CreateBrushIndirect(BrushLog);
     SelectObject(PaintDC,Sun_in);

     TextOut(PaintDC,0,PaintInfo.rcPaint.bottom-45,'slo',5);
     TextOut(PaintDC,0,PaintInfo.rcPaint.bottom-30,'b:',2);
     TextOut(PaintDC,0,PaintInfo.rcPaint.bottom-15,'l:',2);

     {Svanda nahradil hodnotu 11 za MaxSpots+1}

     for uhel:=1 to MaxSpots+1 do begin
                          MoveTo(PaintDC,Uhel*Vel+5,PaintInfo.rcPaint.bottom-45);
                          LineTo(PaintDC,Uhel*vel+5,PaintInfo.rcPaint.bottom);
                         end;

     for uhel:=1 to 3 do begin
                          MoveTo(PaintDC,0,PaintInfo.rcPaint.bottom-uhel*15);
                          LineTo(PaintDC,(maxspots+1)*Vel+5,PaintInfo.rcPaint.bottom-uhel*15);
                       end;

     DeleteObject(Styl_Cary);
     DeleteObject(Sun_in);

     dispose(ch);

  end;

procedure TMyWindow.WMSize(var Msg:TMessage);
begin
   inherited WMSize(Msg);
   Stred.X:=LOWORD(Msg.lParam) div 2;
	 Stred.Y:=(HIWORD(Msg.lParam) div 2)-25;
	 if Stred.X<Stred.Y then r:=Round(0.8*Stred.X)
                      else r:=Round(0.8*Stred.Y);
   Vel:=(LOWORD(Msg.lParam)-5) div (maxspots+1);
   SendMessage(parent^.hWindow,wm_first+wm_chper,0,0);
   InvalidateRect(hWindow,nil,true);
end;

procedure TMyWindow.WMLbuttonDown(var Msg:TMessage);
begin
   inherited WMLButtonDown(Msg);
   if (Msg.LParamHi>Attr.H-75) and (((Msg.LParamLo-5) div Vel)<=Data^.size)
   and (((Msg.LParamLo-5) div Vel)>0) then begin
       ActiveID:=(Msg.LParamLo-5) div Vel;
       InvalidateRect(hWindow,nil,false);
       Msg.Result:=0;
    end;
end;

procedure TMyWindow.WMRButtonUp(var Msg:TMessage);
var SpotDlg:PSpotDlg;

begin
   if (Msg.LParamHi>Attr.H-75) and (((Msg.LParamLo-5) div Vel)>0) then
   if (ActiveID=(Msg.LParamLo-5) div Vel) then begin
       SpotDlg:=new(PSpotDlg,Init(@Self,Data^.Spots[ActiveID]^.Q,Data^.Spots[ActiveID]^.VR*Data^.R,Data^.R,
                    Data^.Spots[ActiveID]^.cislo, Data^.Spots[ActiveID]^.pocet, Data^.Spots[ActiveID]^.pocetstred));
       if SpotDlg^.Execute=id_ok then begin
          Data^.SetSpot(ActiveID,SpotDlg^.Q,SpotDlg^.R/Data^.R,SpotDlg^.cislo, SpotDlg^.Pocet, SpotDlg^.PocetStred);
          SendMessage(parent^.hWindow,wm_first+wm_chper,0,0);
        end;
       Dispose(SpotDlg,Done);
       InvalidateRect(hWindow,nil,false);
   end
   else if ((Msg.LParamLo-5) div Vel<=Data^.size) and (ActiveID>0) then begin
       ActiveID:=(Msg.LParamLo-5) div Vel;
       InvalidateRect(hWindow,nil,false);
   end;
   Msg.Result:=0;
end;

function TMyWindow.CanClose:boolean;
const Nadpis:PChar='Chcete ztratit data?';
      Text:PChar='Data nejsou uloena. Chcete je uloit?';
var   pom:integer;
      Msg:TMessage;
begin
   CanClose:=True;
   if IsChanged then begin
      pom:=MessageBox(hWindow,Text,Nadpis,MB_YESNOCANCEL);
      case pom of
        idYes: SaveData(Msg);
        idCancel: CanClose := false;
        idNo: begin
                CanClose := true;
                isChanged := false;
              end;
      end;

   if isChanged then CanClose := false;


   end;
end;

procedure TMyWindow.ChooseSun(var Msg:TMessage);
var S:PDosStream;
begin
end;

procedure TMyWindow.SaveData(var Msg:TMessage);
var S:PStream;
    maskstring : String;
    nulovy, spatny : boolean;
begin
  maskstring := '*.sun'+chr(0);
  spatny := (strcomp(fullfilename, @maskstring[1]))=0;
  nulovy := StrLen(FullFileName)=0;

    if nulovy or spatny then SaveDataAs(Msg)
    else
 begin
   S:=New(PDosStream,Init(FullFileName,stCreate));

   Hlava^.Store(S^);
   Dispose(S,Done);
   IsChanged:=false;
 end;
end;

procedure TMyWindow.SaveDataAs(var Msg:TMessage);
const Nadpis:PChar='Varovn! Pepsat soubor?';
      Text:PChar='Soubor ji existuje! Chcete jej pepsat?';

var S:PStream;
  dirinfo: TSearchRec;
  pom:integer;
begin
  StrCopy(OpenFN.lpstrFile,FileName);
  OpenFN.lpstrTitle:=SaveFile;
  if GetSaveFileName(OpenFN) then begin
      {Pridal Svanda -- kontroluje, zda pozadovany soubor jiz nahodou neexistuje
      a zamezuje tak jeho prepsani}

      {$I-}
      FindFirst(FullFileName, faAnyfile, dirinfo);
      if DosError = 0 then
      {$I+}
        begin
          pom:=MessageBox(hWindow,Text,Nadpis,MB_YESNOCANCEL);
          if pom=IDYES then
            begin
              S:=New(PDosStream,Init(FullFileName,stCreate));
              Hlava^.Store(S^);
              Dispose(S,Done);
              IsChanged:=false;
            end;
        end
      else
        begin
          S:=New(PDosStream,Init(FullFileName,stCreate));
          Hlava^.Store(S^);
          Dispose(S,Done);
          IsChanged:=false;
        end;
    end;
end;

procedure TMyWindow.AddObs(var Msg:TMessage);
begin
    Data:=New(PData,Init(Hlava));
    InvalidateRect(hWindow,nil,true);
end;

procedure TMyWindow.DeleteObs(var Msg:TMessage);
begin
    if Hlava=Data then Hlava:=Data^.Next;
    Dispose(Data,Done);
    if Hlava=nil then Done;
end;

procedure TMyWindow.PrevObs(var Msg:TMessage);
begin
   if Data^.Pred<>nil then begin
      Data:=Data^.Pred;
      InvalidateRect(hWindow,nil,true);
    end;
end;

procedure TMyWindow.NextObs(var Msg:TMessage);
begin
   if Data^.Next<>nil then begin
      Data:=Data^.Next;
      InvalidateRect(hWindow,nil,true);
    end;
end;

procedure TMyWindow.Souradnice;
var SpotDlg:PSpotDlg;
begin
  if ActiveID>0 then begin
    SpotDlg:=new(PSpotDlg,Init(@Self,Data^.Spots[ActiveID]^.Q,Data^.Spots[ActiveID]^.VR*Data^.R,Data^.R,
                               Data^.Spots[ActiveID]^.cislo, Data^.Spots[ActiveID]^.pocet, Data^.Spots[ActiveID]^.pocetstred));
{ Srovnej s predchozim, toto zde bylo, preklep (R misto VR) zpusoboval spatne pocitani souradnic pri oprave
    SpotDlg:=new(PSpotDlg,Init(@Self,Data^.Spots[ActiveID]^.Q,Data^.Spots[ActiveID]^.R*Data^.R,Data^.R,
                               Data^.Spots[ActiveID]^.cislo, Data^.Spots[ActiveID]^.pocet,
                               Data^.Spots[ActiveID]^.pocetstred));}
    if SpotDlg^.Execute=id_ok then begin
       Data^.SetSpot(ActiveID,SpotDlg^.Q,SpotDlg^.R/Data^.R,SpotDlg^.cislo, SpotDlg^.Pocet, SpotDlg^.PocetStred);
       SendMessage(parent^.hWindow,wm_first+wm_chper,0,0);
    end;
    Dispose(SpotDlg,Done);
    InvalidateRect(hWindow,nil,true);
  end;
end;

procedure TMyWindow.Datum;
var DatDlg:PDatumDlg;
begin
    DatDlg:=new(PDatumDlg,Init(@Self,Data^.Datum,Data^.Cas,Data^.R,@Data^.Pozorovatel[1],Data^.Podminky, Data^.Obraz));
    if DatDlg^.Execute=id_ok then begin
       Data^.SetDate(DatDlg^.Dat,DatDlg^.Cas,DatDlg^.R,DatDlg^.PozPodm, DatDlg^.PozObr);
       SendMessage(parent^.hWindow,wm_first+wm_chper,0,0);
       Data^.Calculate;
    end;
    Dispose(DatDlg,Done);
    InvalidateRect(hWindow,nil,true);
end;

procedure TMyWindow.Iteruj;
var IterDlg:PIterDlg;
begin
    IterDlg:=new(PIterDlg,Init(@Self,Data));
    if IterDlg^.Execute=id_ok then begin
       Data^.Iter(IterDlg^.Iter_1,IterDlg^.Iter_2);
       SendMessage(parent^.hWindow,wm_first+wm_chper,0,0);
    end;
    Dispose(IterDlg,Done);
    InvalidateRect(hWindow,nil,true);
end;

procedure TMyWindow.Vyhodnot;
const Nadpis:PChar='Vyhodnocen kresby';
  var
    i: integer;
    g, f, rel, gc, fc, rc : Integer;
    gn, fn, rn, gs, fs, rs : Integer;
    Text: PChar;
    S : string;
    TextStr : String;
begin
  g := Data^.Size; f:=0; rel:=0;
  gc := 0; fc := 0; Rc := 0;
  gs := 0; fs := 0; Rs := 0;
  gn := 0; fn := 0; Rn := 0;
  for i:=1 to Data^.Size do
    begin
      f := f + Data^.Spots[i]^.pocet;
      if Data^.Spots[i]^.pocetstred <> 0 then
        begin
          inc(gc);
          fc := fc+Data^.Spots[i]^.pocetstred;
        end;
      if Data^.Spots[i]^.b >= 0 then
        begin
          inc(gn);
          fn := fn+data^.spots[i]^.pocet;
        end
      else
        begin
          inc(gs);
          fs := fs+data^.spots[i]^.pocet;
        end
    end;
  rel := 10*g+f;
  rc := 10*gc+fc;
  rs := 10*gs+fs;
  rn := 10*gn+fn;
  Str(g, s);
  TextStr := 'g='+s;
  Str(f, s);
  TextStr := TextStr+'       f='+s;
  Str(rel, s);
  TextStr := TextStr+'       r='+s+#13;
  Str(gc, s);
  TextStr := TextStr+'gc='+s;
  Str(fc, s);
  TextStr := TextStr+'       fc='+s;
  Str(rc, s);
  TextStr := TextStr+'       rc='+s+#13;
  Str(gn, s);
  TextStr := TextStr+'gn='+s;
  Str(fn, s);
  TextStr := TextStr+'       fn='+s;
  Str(rn, s);
  TextStr := TextStr+'       rn='+s+#13;
  Str(gs, s);
  TextStr := TextStr+'gs='+s;
  Str(fs, s);
  TextStr := TextStr+'       fs='+s;
  Str(rs, s);
  TextStr := TextStr+'       rs='+s+#13+#0;
  Text := @TextStr[1];
  i:=MessageBox(hWindow,Text,Nadpis,MB_OK);
end;

procedure TMyWindow.Insert;
var SpotDlg:PSpotDlg;
begin

{Svanda zmenil 10 na maxspots (melo by symbolizovat pocet skvrn)}

  if Data^.Size<maxspots then begin
    SpotDlg:=new(PSpotDlg,Init(@Self,0,0,Data^.R,Data^.Size+1, 0,0));
    if SpotDlg^.Execute=id_ok then begin
       Data^.InsertSpot(SpotDlg^.Q,SpotDlg^.R/Data^.R,SpotDlg^.cislo, SpotDlg^.Pocet, SpotDlg^.PocetStred);
       SendMessage(parent^.hWindow,wm_first+wm_chper,0,0);
    end;
    Dispose(SpotDlg,Done);
    ActiveID:=Data^.size;
    if Data^.Size=1 then SetMenu(MF_ENABLED);
    InvalidateRect(hWindow,nil,true);
  end;
end;

procedure TMyWindow.Delete;
var DeleteDlg:PDialog;
begin
  if (Data^.Size>0) and (ActiveID>0) then begin
    DeleteDlg:=new(PDialog,Init(@Self,'DELETE'));
    if DeleteDlg^.Execute=id_ok then begin
       Data^.DeleteSpot(ActiveID);
       SendMessage(parent^.hWindow,wm_first+wm_chper,0,0);
    end;
    if (ActiveID>Data^.size) then ActiveID:=Data^.size;
    Dispose(DeleteDlg,Done);
    if Data^.Size=0 then SetMenu(MF_GRAYED);
    InvalidateRect(hWindow,nil,true);
  end;
end;

procedure TMyWindow.NextSpot;
begin
   inc(ActiveID);
   if ActiveID>Data^.Size then ActiveID:=1;
   InvalidateRect(hWindow,nil,false);
end;

procedure TMyWindow.LastSpot;
begin
   dec(ActiveID);
   if ActiveID<1 then ActiveID:=Data^.Size;
   InvalidateRect(hWindow,nil,false);
end;

procedure TMyWindow.SelectSpot;
var SpotDlg:PSpotDlg;

begin
 if Data^.Size>0 then begin
   SpotDlg:=new(PSpotDlg,Init(@Self,Data^.Spots[ActiveID]^.Q,Data^.Spots[ActiveID]^.VR*Data^.R,Data^.R,
                   Data^.Spots[ActiveID]^.cislo, Data^.Spots[ActiveID]^.pocet, Data^.Spots[ActiveID]^.pocetstred));
   if SpotDlg^.Execute=id_ok then Data^.SetSpot(ActiveID,SpotDlg^.Q,SpotDlg^.R/Data^.R,SpotDlg^.cislo,
                                                spotdlg^.pocet, spotdlg^.pocetstred);
   Dispose(SpotDlg,Done);
   InvalidateRect(hWindow,nil,false);
 end;
end;

{ ***************************** TMainWindow ************************** }

constructor TMainWindow.Init(ATitle:PChar;AMenu:HMenu);
begin
   inherited Init(ATitle,AMenu);
   ToolBar:=New(PToolBar,Init(@Self));
   StatusBar:=New(PStatusBar,Init(@Self));
end;

destructor TMainWindow.Done;
begin
   Dispose(ToolBar,Done);
   inherited Done;
end;

procedure TMainWindow.GetWindowClass(var WndClass: TWndClass);
begin
  inherited GetWindowClass(WndClass);
  WndClass.HIcon := LoadIcon(HInstance, 'EINSTEIN');
end;

procedure TMainWindow.SetUpWindow;
begin
   ChildMenuPos:=3;
   WinCount:=0;

   inherited SetUpWindow;

{   Hlava:=nil;}
   StrCopy(FullFileName, '');
   StrCopy(FileName, '*.sun');
   FillChar(Filter, SizeOf(Filter), #0);  { Set up for double null at end }
   StrCopy(Filter, 'FOTOSFEREX - data(*.sun)');
   StrCopy(@Filter[25], '*.sun');
   StrCopy(@Filter[31], 'Vechny soubory(*.*)');
   StrCopy(@Filter[52], '*.*');
   FillChar(OpenFN, SizeOf(TOpenFileName), #0);
   with OpenFN do
   begin
     hInstance     := HInstance;
     hwndOwner     := HWindow;
     lpstrFile     := FullFileName;
     lpstrFilter   := Filter;
     lpstrFileTitle:= FileName;
     lpstrCustomFilter:=nil;
     flags         := ofn_FileMustExist;
     lStructSize   := sizeof(TOpenFileName);
     nFilterIndex  := 1;       {Index into Filter String in lpstrFilter}
     nMaxFile      := SizeOf(FullFileName);
     lpstrDefEXt   := DefExt;
   end;

end;

procedure TMainWindow.ChangeCount(var Msg:TMessage);

procedure SetMenu(Style:word);
begin
     EnableMenuItem(GetMenu(hWindow),170,Style);
     EnableMenuItem(GetMenu(hWindow),117,Style);
     EnableMenuItem(GetMenu(hWindow),115,Style);
     EnableMenuItem(GetMenu(hWindow),114,Style);
     EnableMenuItem(GetMenu(hWindow),108,Style);
     EnableMenuItem(GetMenu(hWindow),105,Style);
     EnableMenuItem(GetMenu(hWindow),106,Style);
     EnableMenuItem(GetMenu(hWindow),102,Style);
{Aby se to tam nepletlo}
{     EnableMenuItem(GetMenu(hWindow),118,Style);
     EnableMenuItem(GetMenu(hWindow),119,Style);
     EnableMenuItem(GetMenu(hWindow),120,Style);
     EnableMenuItem(GetMenu(hWindow),121,Style);}
     EnableMenuItem(GetMenu(hWindow),24335,Style);
     EnableMenuItem(GetMenu(hWindow),24336,Style);
     EnableMenuItem(GetMenu(hWindow),24337,Style);
     EnableMenuItem(GetMenu(hWindow),24338,Style);
end;

begin
   if Msg.wParam=1 then inc(WinCount);
   if Msg.wParam=2 then dec(WinCount);
   if WinCount=0 then SetMenu(MF_GRAYED)
      else if WinCount=1 then SetMenu(MF_ENABLED);
end;

procedure TMainWindow.LoadData(var Msg:TMessage);
var S:PStream;

begin
   StrCopy(OpenFN.lpstrFile,FileName);
   OpenFN.lpstrTitle:=OpenFile;
   if GetOpenFileName(OpenFN) then begin
     S:=New(PDosStream,Init(FullFileName,stOpenRead));
     Application^.MakeWindow(new(PMyWindow,Load(@Self,S^)));
     Dispose(S,Done);
   end;
   SendMessage(StatusBar^.hWindow,WM_PAINT,0,0);
end;

procedure TMainWindow.AddSun(var Msg:TMessage);
begin
   Application^.MakeWindow(new(PMyWindow,Init(@Self,NazevApp)));
end;

procedure TMainWindow.Exit;
begin
   Done;
end;

procedure TMainWindow.About;
var AboutDlg:PDialog;

begin
   AboutDlg:=new(PDialog,Init(@Self, 'ABOUT'));
   AboutDlg^.Execute;
   Dispose(AboutDlg,Done);
   InvalidateRect(hWindow,nil,false);
end;

procedure TMainWindow.Pomoc;
begin
    WinHelp(hWindow,HelpName,HELP_INDEX,0);
end;

procedure TMainWindow.PomocIndex;
begin
    WinHelp(hWindow,HelpName,HELP_HELPONHELP,0);
end;

procedure TMainWindow.PomocProgram;
begin
    WinHelp(hWindow,HelpName,HELP_CONTEXT,101);
end;

procedure TMainWindow.WMSize(var Msg: TMessage);
var R:TRect;

procedure NotifyChild(P:PWindow);far;
begin
   if P<>nil then
      SendMessage(P^.hWindow,AM_CalcParentClientRect,1,LongInt(@R));
end;


begin
  if (Scroller <> nil) and (Msg.WParam <> sizeIconic) then
    Scroller^.SetPageSize;
  if Msg.wParam = sizeNormal then
  begin
    GetWindowRect(HWindow, R);
    Attr.H := R.bottom - R.top;
    Attr.W := R.right - R.left;
  end;
  GetClientRect(HWindow, R);
  ForEach(@NotifyChild);
  SetWindowPos(ClientWnd^.HWindow, 0, R.Left, R.Top,
                                      R.Right - R.Left,
                                      R.Bottom - R.Top, swp_NoZOrder);
end;

procedure TMainWindow.SetStatusText(var Msg:TMessage);
begin
   StatusBar^.SetStatusInfo(PChar(Msg.lParam));
end;



{ ************************** APLIKACE ***************************** }
{na accelerators- pro iniaci}
procedure TMyApp.InitInstance;
begin
  TApplication.InitInstance;
  HAccTable := LoadAccelerators(HInstance, NazevApp);
end;

{pro spravne zachazeni s acceleratory}
function TMyApp.ProcessAppMsg(var Message: TMsg): Boolean;
begin
  ProcessAppMsg := ProcessAccels(Message) or ProcessDlgMsg(Message);
end;

procedure TMyApp.InitMainWindow;

  begin
    MainWindow := New(PMainWindow, Init(NazevApp,LoadMenu(hInstance,NazevApp)));
  end;

var
   MyApp: TMyApp;
   SouborSPzrvtl : Text;
   DirInfo : TSearchRec;
   Radek, Identifikace : String;
   PIdent : PChar;
   pozor : array[1..255] of array[1..20] of Char;
   i : Integer;
{   Path: array[0..fsPathName] of Char;}
   Dir: array[0..fsDirectory] of Char;
   Name: array[0..fsFileName] of Char;
   Ext: array[0..fsExtension] of Char;
   PozFileName : String;

begin
  {Svanda pridal delsi telo:
  ze souboru obsrvs.dat (paklize jej najde) precte jmena vsech dostupnych
  pozorovatelu a naplni je do roletoveho menu v prislusnem dialogu SUNu}
  PocetPozorovatelu := 0;
  Pozorovatele[0] := 'unknow';
  radek := ParamStr(0);
  FileSplit(@Radek[1], Dir, Name, Ext);
  identifikace := '';
  pozfilename := 'obsrvs.dat'+chr(0);
  strcat(dir, @pozfilename[1]);
  for i:=0 to strlen(dir) do identifikace := identifikace+dir[i];

  {$I-}
  FindFirst(dir,faAnyFile, DirInfo);
  if DosError = 0 then
  {$I+}
    begin
      Assign(SouborSPzrvtl, identifikace);
      Reset(SouborSPzrvtl);
      while not Eof(SouborSPzrvtl) do
        begin
          ReadLn(SouborSPzrvtl, Radek);
          Inc(PocetPozorovatelu);
          Identifikace :=Copy(Radek, 2,3)+'/'+Copy(Radek, 8, length(Radek)-8);
          if Length(Identifikace) >= 20 then
            begin
              for i:=1 to 19 do
                pozor[pocetpozorovatelu][i] := Identifikace[i];
              pozor[pocetpozorovatelu][20] := Chr(0);
            end
          else
            begin
              for i:=1 to Length(Identifikace) do
                pozor[pocetpozorovatelu][i] := Identifikace[i];
              pozor[pocetpozorovatelu][length(identifikace)+1] := Chr(0);
            end;
          New(Pozorovatele[PocetPozorovatelu]);
          Pozorovatele[PocetPozorovatelu] := @pozor[pocetpozorovatelu];
        end;
     end;
  {a nasleduje klasicke ultra kratke telo OOP}
  MyApp.Init(NazevApp);
  MyApp.Run;
  MyApp.Done;
end.