unit ToolBar;

{muj zjednoduseny toolbar
 (C) 1997 Petr Kubanek - EinsteinSoftware
}

interface

{$R toolbar.res}
{$X+}

uses OWindows, WinTypes, WinProcs, Strings, Ids;


const AM_CalcParentClientRect=wm_user+99;
      AM_SetStatusText=wm_user+100;
      ToolSize=2;
      BitmapName:array[1..ToolSize] of PChar=('FileOpen','FileSave');
      HintText:array[1..ToolSize] of PChar=('Oteven souboru','Uloen souboru');
      Commands:array[1..ToolSize] of word=(cm_loaddata,cm_savedata);
      st_btdown=2;
      st_normal=1;
      st_disabled=3;

type PTool=^TTool;
     TTool=object
          command:word;
          Bitmap:HBitmap;
          state:byte;
          Pozice:TPoint;
          PoziceBottom:TPoint;
          constructor Init(APoziceX,APoziceY:integer;BitName:PChar;ACommand:word);
          destructor Done;virtual;
          procedure Paint(DC,MemDC:HDC);
          procedure StartCapture;
          procedure EndCapture;
          procedure ChangeState(new_state:byte);
     end;

     PToolBar = ^TToolBar;
     TToolBar = object(TWindow)
        MouseState,DownBt:byte;
        Tools:array[1..ToolSize] of PTool;
        constructor Init(AParent:PWindowsObject);
        destructor Done;virtual;
        function GetClassName:PChar;virtual;
        procedure GetWindowClass(var WC: TWndClass);virtual;
        procedure AMCalcParentClientRect(var Msg: TMessage);
            virtual AM_CalcParentClientRect;
        procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
        procedure MouseMove(var Msg:TMessage);virtual wm_first+wm_mousemove;
        procedure WMLButtonDown(var Msg: TMessage); virtual wm_First + wm_LButtonDown;
        procedure WMLButtonUp(var Msg: TMessage); virtual wm_First + wm_LButtonUp;
     end;

     PStatusBar = ^TStatusBar;
     TStatusBar = object (TWindow)
        StatusText:PChar;
        constructor Init(AParent:PWindow);
        destructor Done;virtual;
        function GetClassName:PChar;virtual;
        procedure GetWindowClass(var WC: TWndClass);virtual;
        procedure AMCalcParentClientRect(var Msg: TMessage);
            virtual AM_CalcParentClientRect;
        procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
        procedure SetStatusInfo(AStatusText:PChar);
     end;


implementation

constructor TTool.Init(APoziceX,APoziceY:integer;BitName:PChar;ACommand:word);
var BitInfo:TBitmap;

begin
   Pozice.X:=APoziceX;
   Pozice.Y:=APoziceY;
   Bitmap:=LoadBitmap(HInstance,BitName);
   GetObject(Bitmap,sizeof(TBitmap),@BitInfo);
   PoziceBottom.X:=Pozice.X+BitInfo.bmWidth+2;
   PoziceBottom.Y:=Pozice.Y+BitInfo.bmHeight+2;
   State:=st_normal;
   Command:=ACommand;
end;

procedure TTool.Paint(DC,MemDC:HDC);
var OldBitmap:HBitmap;
    OldPen,NewPen:HPen;

procedure DrawnUpRect(Pen:HPen);
begin
   OldPen:=SelectObject(DC,Pen);
   MoveTo(DC,PoziceBottom.X,Pozice.Y);
   LineTo(DC,Pozice.X,Pozice.Y);
   LineTo(DC,Pozice.X,PoziceBottom.Y);
   SelectObject(DC,OldPen);
end;

procedure DrawnDownRect(Pen:HPen);
begin
   OldPen:=SelectObject(DC,Pen);
   MoveTo(DC,PoziceBottom.X,Pozice.Y);
   LineTo(DC,PoziceBottom.X,PoziceBottom.Y);
   LineTo(DC,Pozice.X,PoziceBottom.Y);
   SelectObject(DC,OldPen);
end;

begin
  if state=st_btdown then
  begin
   NewPen:=GetStockObject(Black_PEN);
   DrawnUpRect(NewPen);
   DeleteObject(NewPen);
   NewPen:=GetStockObject(White_PEN);
   DrawnDownRect(NewPen);
   DeleteObject(NewPen);
   OldBitmap:=SelectObject(MemDC,Bitmap);
   BitBlt(DC,Pozice.X+2,Pozice.Y+2,23,23,MemDC,0,0,srccopy);
   SelectObject(MemDC,OldBitmap);
  end
  else begin
   NewPen:=GetStockObject(WHITE_PEN);
   DrawnUpRect(NewPen);
   DeleteObject(NewPen);
   NewPen:=GetStockObject(BLACK_PEN);
   DrawnDownRect(NewPen);
   DeleteObject(NewPen);
   OldBitmap:=SelectObject(MemDC,Bitmap);
   BitBlt(DC,Pozice.X+1,Pozice.Y+1,23,23,MemDC,0,0,srccopy);
   SelectObject(MemDC,OldBitmap);
  end;
end;

destructor TTool.Done;
begin
   DeleteObject(Bitmap);
end;

procedure TTool.StartCapture;
begin

end;

procedure TTool.EndCapture;
begin

end;

procedure TTool.ChangeState(new_state:byte);
begin

end;


constructor TToolBar.Init(AParent:PWindowsObject);

var count:byte;
begin
   inherited Init(AParent,nil);
   Attr.Style := ws_Child or ws_Visible or ws_Border;
   SetFlags(wb_MDIChild, False);
   Attr.X := -1;
   Attr.Y := -1;
   Attr.W := 200;
   Attr.H := 33;
   DownBt:=0;
   for count:=1 to ToolSize do
     Tools[count]:=new(PTool,Init((count-1)*27+1,1,BitmapName[count],Commands[Count]));
end;

destructor TToolBar.Done;
var count:byte;
begin
   for count:=1 to ToolSize do Dispose(Tools[count],Done);
   inherited Done;
end;

function TToolbar.GetClassName: PChar;
begin
  GetClassName := 'MyToolbar';
end;

procedure TToolbar.GetWindowClass(var WC: TWndClass);
begin
  TWindow.GetWindowClass(WC);
  WC.hbrBackground := GetStockObject(LTGray_Brush);
end;


procedure TToolBar.AMCalcParentClientRect(var Msg: TMessage);
begin
   Attr.W:=PRect(Msg.LParam)^.Right-PRect(Msg.LParam)^.Left;
   InvalidateRect(HWindow,nil,True);
   SetWindowPos(HWindow, 0, -1, -1, Attr.W+2, Attr.H,
        swp_NoZOrder or swp_NoRedraw);
   PRect(Msg.LParam)^.Top:=PRect(Msg.LParam)^.Top+Attr.H-Attr.Y-2;
end;

procedure TToolBar.Paint(PaintDC: HDC; var PaintInfo: TPaintStruct);
var count:byte;
    MemDC:HDC;
    Brush,OldBrush:HBrush;
begin
    MemDC:=CreateCompatibleDC(PaintDC);
    Brush:=GetStockObject(Black_Brush);
    OldBrush:=SelectObject(PaintDC,Brush);
    for count:=1 to ToolSize do Tools[count]^.Paint(PaintDC,MemDC);
    DeleteDC(MemDC);
    SelectObject(PaintDC,OldBrush);
end;

procedure TToolBar.MouseMove(var Msg:TMessage);
begin
   if DownBt<>0 then begin
     if (HIWORD(Msg.LParam)>Tools[DownBt]^.PoziceBottom.Y) or
        (HIWORD(Msg.LParam)<Tools[DownBt]^.Pozice.Y) or
        (LOWORD(Msg.LParam)>Tools[DownBt]^.PoziceBottom.X) or
        (LOWORD(Msg.LParam)<Tools[DownBt]^.Pozice.X)
        then begin
          Tools[DownBt]^.State:=st_normal;
          SendMessage(parent^.hWindow,AM_SetStatusText,1,LongInt(nil));
          DownBt:=0;
          InvalidateRect(hWindow,nil,false);
        end;
     end;
end;

procedure TToolBar.WMLButtonDown(var Msg: TMessage);
begin
   if (LO(Msg.LParam) mod 30>2) and (LO(Msg.LParam) mod 30<28) then
      if (LO(Msg.LParam) div 30)<ToolSize then
        begin
          DownBt:=(LO(Msg.LParam) div 30)+1;
          Tools[DownBt]^.State:=st_btdown;
          SendMessage(parent^.hWindow,AM_SetStatusText,1,LongInt(HintText[DownBt]));
        end;
   InvalidateRect(hWindow,nil,false);
end;

procedure TToolBar.WMLButtonUp(var Msg:TMessage);
begin
  if DownBt<>0 then begin
    Tools[DownBt]^.State:=st_normal;
    SendMessage(parent^.hwindow,WM_COMMAND,Tools[DownBt]^.command,0);
    SendMessage(parent^.hWindow,AM_SetStatusText,1,LongInt(nil));
    DownBt:=0;
    InvalidateRect(hWindow,nil,false);
  end;
end;

{***************implementace Status Baru*******************}

constructor TStatusBar.Init(AParent:PWindow);

begin
   inherited Init(AParent,nil);
   Attr.Style := ws_Child or ws_Visible or ws_Border;
   SetFlags(wb_MDIChild, False);
   Attr.X := -1;
   Attr.Y := -1;
   Attr.H := 20;
   Attr.W := 200;
   StatusText:=nil;
end;

destructor TStatusBar.Done;
var count:byte;
begin
   inherited Done;
end;

function TStatusBar.GetClassName: PChar;
begin
  GetClassName := 'MyStatusbar';
end;

procedure TStatusbar.GetWindowClass(var WC: TWndClass);
begin
  TWindow.GetWindowClass(WC);
  WC.hbrBackground := GetStockObject(LTGray_Brush);
end;


procedure TStatusBar.AMCalcParentClientRect(var Msg: TMessage);
begin
   Attr.Y:=Prect(Msg.LParam)^.Bottom-Attr.H;
   Attr.X:=-1;
   Attr.W:=PRect(Msg.LParam)^.Right-PRect(Msg.LParam)^.Left;
   InvalidateRect(HWindow,nil,True);
   SetWindowPos(HWindow, 0, Attr.X, Attr.Y, Attr.W+2, Attr.H+2,
        swp_NoZOrder or swp_NoRedraw);
   PRect(Msg.LParam)^.Bottom:=PRect(Msg.LParam)^.Bottom-Attr.H+2;
end;

procedure TStatusBar.Paint(PaintDC: HDC; var PaintInfo: TPaintStruct);
var Brush,OldBrush:HBrush;
    Pen,OldPen:HPen;
begin
   SetBkColor(PaintDC,RGB(192,192,192));
   Brush:=GetStockObject(LTGRAY_BRUSH);
   OldBrush:=SelectObject(PaintDC,Brush);
   Rectangle(PaintDC,1,1,200,Attr.H-3);
   DeleteObject(Brush);
   SelectObject(PaintDC,OldBrush);
   if StatusText<>nil then
    TextOut(PaintDC,2,2,StatusText,StrLen(StatusText));
end;

procedure TStatusBar.SetStatusInfo(AStatusText:PChar);
begin
   StatusText:=AStatusText;
   InvalidateRect(hWindow,nil,false);
end;

begin

end.